#ifndef __PCI3001_DEFINE_H
#define __PCI3001_DEFINE_H
	
enum {
	APCI3001_CHANNEL_0,
	APCI3001_CHANNEL_1,
	APCI3001_CHANNEL_2,
	APCI3001_CHANNEL_3,
	APCI3001_CHANNEL_4,
	APCI3001_CHANNEL_5,
	APCI3001_CHANNEL_6,
	APCI3001_CHANNEL_7,
	APCI3001_CHANNEL_8,
	APCI3001_CHANNEL_9,
	APCI3001_CHANNEL_10,
	APCI3001_CHANNEL_11,
	APCI3001_CHANNEL_12,
	APCI3001_CHANNEL_13,
	APCI3001_CHANNEL_14,
	APCI3001_CHANNEL_15
};

/* Digital input/output related */
#define	PCI3001_DIGITAL_INPUT_NUMBER			4
#define	PCI3001_DIGITAL_OUTPUT_NUMBER			4

/* Analog input related */
#define	PCI3001_ANALOG_INPUT_NUMBER				16

/* Analog input mode related */
#define PCI3001_INPUT_MODE_UNDEFINED	0x0
#define PCI3001_INPUT_MODE_SINGLE_ENDED	0x1
#define PCI3001_INPUT_MODE_DIFFERENTIAL	0x2

#define APCI3001_DISABLE		0
#define APCI3001_ENABLE			1

// Analog output mode
#define PCI3001_OUTPUT_MODE_UNIPOLAR			0
#define PCI3001_OUTPUT_MODE_BIPOLAR				1

#define PCI3001_GAIN_1			0
#define PCI3001_GAIN_2			1
#define PCI3001_GAIN_5			2
#define PCI3001_GAIN_10		    3

#define APCI3001_BIPOLAR		0
#define APCI3001_UNIPOLAR		1

#define APCI3001_SIMPLE_MODUS	30	
#define APCI3001_DELAY_MODUS	31
#define APCI3001_DELAY_1_MODUS	32

#define APCI3001_SINGLE			40
#define APCI3001_CONTINUOUS		41

#define APCI3001_DMA_NOT_USED	50
#define APCI3001_DMA_USED		51

// External trigger mode
#define PCI3001_EXT_TRIGGER_DISABLED			0x0
#define PCI3001_EXT_TRIGGER_ENABLED_LOW		0x1
#define PCI3001_EXT_TRIGGER_ENABLED_HIGH		0x2
#define PCI3001_EXT_TRIGGER_ENABLED_BOTH		0x3

// Software trigger mode
#define PCI3001_SOFT_TRIGGER_DISABLED			0x0
#define PCI3001_SOFT_TRIGGER_ENABLED			0x1

// Trigger types
#define PCI3001_TRIGGER_ONE_SHOT				0x0
#define PCI3001_TRIGGER_SEQUENCE_TRIGGER		0x8
#define PCI3001_TRIGGER_SINGLE_SEQUENCE		0xC




#endif
